/**
 * Copyright shohei909 ( http://wonderfl.net/user/shohei909 )
 * MIT License ( http://www.opensource.org/licenses/mit-license.php )
 * Downloaded from: http://wonderfl.net/c/fpk6
 */

//落ちものゲー　LIVE CODING 2010/09/10 2010/09/11
/*

操作方法
    Z : 回転(rotate)
    X : 逆回転(reverse)
    
ルール
    市松模様
    ■　□
    □　■　を作ると消える。
    

　作ってはみたけれども、あんまりおもしろくなりそうにないので、
　これ以上は作りこまないと思います。
　
　LIVE CODING　に来てくれた方々、ありがとうございましたm(_ _)m
*/

package {
    import flash.display.Sprite;
    [SWF(backgroundColor = "#CCCCCC")]
    public class FlashTest extends Sprite {
        public function FlashTest() {
            addEventListener("addedToStage",init);
        }
        private function init(e:*):void{
            // write as3 code here..
            removeEventListener("addedToStage",init);
            
            var manField:GameField = new GameField();
            addChild( manField );
            manField.x = 15; manField.y = 10;
            manField.start();
            new Man( stage, manField );
            
            var cpuField:GameField = new GameField();
            //addChild( cpuField );
            cpuField.x = 300;  cpuField.y = 10;
        }
    }
}
import flash.events.KeyboardEvent;
import flash.display.Stage;
import flash.display.Bitmap;
import flash.display.BitmapData;
import flash.events.Event;
import flash.display.Shape;


import flash.display.Graphics;
import flash.display.Sprite;
import frocessing.color.ColorHSV;
    
class GameField extends Sprite{
    public static const W:int = 6;
    public static const H:int = 17;
    public static const cellSize:int = 25; 
    
    
    private var hints:Array = new Array();
    private var hintNum:int = 2;
    //private var blocks:Vector.<StopedBlock> = new Vector.<StopedBlock>();
   
    //停止してるブロックの配置  -1: none, 0: white, 1:black
    public var map:Vector.< Vector.< StopedBlock > > = new Vector.< Vector.< StopedBlock > >(); 
    
    public var movingBlock: MoveSet;
    private var moving:Boolean = false;
    private var wait:Boolean = false;
    
    public var span: int = 40; 
    private var count: int = 0;
    private var delay: int = 0;
    public var stopCount: int = 0;
    private var chane: int = 0;
    
    
    function GameField(){
        var g:Graphics = graphics;
        g.beginBitmapFill(new Netmap(), null, true )
        g.drawRect(0,2*cellSize, W*cellSize, (H-2)*cellSize );
        
        var maskData:Bitmap = new Bitmap( new BitmapData( W*cellSize, (H-2)*cellSize, false, 1 ) );     
        maskData.y = 2*cellSize;
        addChild( maskData );
        this.mask = maskData;
        
        for (var i:int=0; i<W;i++){ 
            map[i] = new Vector.<StopedBlock>();
            for (var j:uint=0;j<H;j++){ 
               map[i][j] = null;
            }
        }
        
        movingBlock = new MoveSet(this);
        addChild( movingBlock );
        setHint();
        this.addEventListener("enterFrame",onFrame);
    }
    
    
    public function start():void{
        moving = true;
        count = 0;
        delay = 0;
        
        while( numChildren > 2){
            removeChildAt(2);
        }
        
        for (var i:int=0; i<W;i++){ 
            for (var j:uint=0;j<H;j++){ 
               map[i][j] = null;
            }
        }
    }
    public function gameOver():void{
        moving = false;
    }

    
    private function onFrame(e:Event):void{
        if(moving == true && delay <= 0 && wait == false ){
            if( movingBlock.data == null ){ addBlock() }
            for (var i:uint=0;i<2;i++){  
                for (var j:uint=0;j<2;j++){
                    if( movingBlock.data[i][j] != null ){
                        if( movingBlock.mapY+j >= H || map[movingBlock.mapX+i-1][movingBlock.mapY+j] != null){
                            var stop:Boolean = true;
                        }
                    }
                }
            }
            if(stop){
                stopCount++;
                if(stopCount > span){
                    stopBlock();
                    
                }
            }else{
                stopCount = 0;
                count++;
                if(count % span == 0){ 
                    movingBlock.y += cellSize;
                    movingBlock.mapY++;
                }
            }
        }else if(moving){
            if( !fall() ){ check() };
            delay--;
        }
    }
    
    
    private function fall():Boolean{
        wait = false; 
        for (var i:int=W-1; i>=0;i--){ 
            for (var j:int=H-2;j>=0;j--){ 
               if(map[i][j] != null && map[i][j+1] == null){
                   map[i][j].y += cellSize;
                   map[i][j].mapY++;
                   map[i][j+1] = map[i][j];
                   map[i][j] = null;
                   wait = true;
               }
            }
        }
        return wait;
    }
    private function check():void{
        for (var i:int=0; i<W-1;i++){ 
            for (var j:uint=0;j<H-1;j++){
               
               if( map[i][j] != null && map[i+1][j] != null && map[i][j+1] != null && map[i+1][j+1] != null ){
                   
                   if( map[i][j].black !=  map[i][j+1].black && map[i][j].black !=  map[i+1][j].black &&  map[i][j].black ==  map[i+1][j+1].black ){
                       removeChild(map[i][j]); map[i][j] = null;
                       removeChild(map[i+1][j]); map[i+1][j] = null;
                       removeChild(map[i][j+1]); map[i][j+1] = null;
                       removeChild(map[i+1][j+1]); map[i+1][j+1] = null;
                       
                       wait = true;
                   }
               }
            }
        }
    }
    private function addBlock():void{
       movingBlock.mapX = 3;
       movingBlock.mapY = 1;
       movingBlock.x = (movingBlock.mapX - 0.5) * cellSize;
       movingBlock.y = (movingBlock.mapY - 0.5) * cellSize;
       movingBlock.data = hints.shift();
       setHint();
       for (var i:uint=0;i<2;i++){  
           for (var j:uint=0;j<2;j++){
               if( movingBlock.data[i][j] != null ){ 
                   movingBlock.addChild( movingBlock.data[i][j] ); 
                   movingBlock.data[i][j].x = i * cellSize;
                   movingBlock.data[i][j].y = j * cellSize;
               }
           }
       }
    }
    private function stopBlock():void{
       for (var i:uint=0;i<2;i++){  
           for (var j:uint=0;j<2;j++){
               if( movingBlock.data[i][j] != null ){ 
                   movingBlock.removeChild( movingBlock.data[i][j] );
                   var block:StopedBlock = new StopedBlock( movingBlock.data[i][j].black );
                   block.mapX = movingBlock.mapX + i - 1;
                   block.mapY = movingBlock.mapY + j - 1;
                   block.x = (movingBlock.mapX + i - 0.5) * cellSize;
                   block.y = (movingBlock.mapY + j - 0.5) * cellSize;
                   map[movingBlock.mapX + i - 1 ][ movingBlock.mapY + j - 1 ] = block;
                   if(movingBlock.mapX + i - 1 == 2 && movingBlock.mapY + j - 1 < 2){gameOver();}
                   addChild( block );
               }
           }
       }
       movingBlock.data = null;
       wait = true;
    }

    
    
    private function setHint():void{
        while( hints.length < hintNum ){
            var hint:Array = [ [ new Block( int( 2*Math.random() ) == 0 ), new Block( int( 2*Math.random() ) == 0 )], [ new Block( int( 2*Math.random() ) == 0 ), null] ]
            hints.push( hint );
        }
    }
}

class MoveSet extends Sprite{
    public var data:Array;
    public var mapX:int = 0, mapY:int = 0;
    private var game:GameField;
    
    function MoveSet( game:GameField ){
        this.game = game;
    }
    
    public function rotate(dir:Boolean):void{
        if(data != null){
           var newData:Array = [[null,null],[null,null]];
           var miss:Boolean = false;
           var map:Vector.<Vector.<StopedBlock>> = game.map;
           for (var i:uint=0;i<2;i++){  
               for (var j:uint=0;j<2;j++){
                   if(dir){var a:uint = j,b:uint = 1 - i}
                   else{ a = 1 - j,b = i }
                   
                   if(data[a][b] != null){
                       if( map[mapX+i-1][mapY+j-1] != null){ miss = true }
                       newData[i][j] = data[a][b];
                   }
               }
           }
           if( miss == false ){ 
               data = newData;    
               for (i=0;i<2;i++){  
                   for (j=0;j<2;j++){
                       if(data[i][j] != null){
                           data[i][j].x = i * GameField.cellSize;
                           data[i][j].y = j * GameField.cellSize;
                       }
                   }
               }
           }
        }
    }
    
    
    public function move(dx:int, dy:int):Boolean{
       var miss:Boolean = false;
       if( data != null ){
           var map:Vector.<Vector.<StopedBlock>> = game.map;
           
           for (var i:uint=0;i<2;i++){  
               for (var j:uint=0;j<2;j++){        
                   if(data[i][j] != null){
                       if( mapX+i+dx-1 < 0 || mapX+i+dx-1 >= GameField.W || mapY+j+dy-1 < 0 || mapY+j+dy-1 >= GameField.H || map[mapX+i+dx-1][mapY+j+dy-1] != null){ miss = true }
                   }
               }
           }
           
           if( miss == false ){ 
               mapX += dx;
               mapY += dy;
               x = (mapX - 0.5) * GameField.cellSize;
               y = (mapY - 0.5) * GameField.cellSize;
           }
           
           if( dx==0  && miss ){
               game.stopCount = game.span + 1; 
           }else if( dx == 0 ){
               game.stopCount = 0
           }
       }
       return miss;
    }
}

class HintField extends Sprite{
    private var blocks:Vector.<Block> = new Vector.<Block>();
    
    function HintField(){
        var g:Graphics = graphics;
    }
}
class Block extends Shape{
    public var black:Boolean;
    function Block( black:Boolean){
        this.black = black;
        
        var g:Graphics = graphics;
        g.lineStyle( 3, 0x113399 );
        g.beginFill( black ? 0x0000000 : 0xFFFFFF );
        g.drawRect(-GameField.cellSize/2, -GameField.cellSize/2, GameField.cellSize, GameField.cellSize );
    }
}

class StopedBlock extends Shape{
    public var black:Boolean;
    public var mapX:int = 0, mapY:int = 0;
    public var life:int = 2; 
    public var damage:Boolean = false; 
    public var color:ColorHSV = new ColorHSV();
    
    function StopedBlock( black:Boolean ){
        this.black = black;
        
        var g:Graphics = graphics;
        g.lineStyle( 0, 0x113399 );
        g.beginFill( black ? 0x000000 : 0xFFFFFF );
        g.drawRect(-GameField.cellSize/2, -GameField.cellSize/2, GameField.cellSize, GameField.cellSize );
    }
    
    public function kill():void{
        color.h = 0;
        color.s = 0.3;
        color.v = 1.0;
        
        change();
    }
    
    public function change():void{
        color.h += Math.random() * 5;
        color.s = 0.3;
        color.v = 1.0;
        
        var g:Graphics = graphics;
        g.clear();
        g.lineStyle( 4, color.value );
        g.beginFill( black ? 0x000000 : 0xFFFFFF );
        g.drawRect(-GameField.cellSize/2+2, -GameField.cellSize/2+2, GameField.cellSize-4, GameField.cellSize-4 );
    }
}



class Man {
    private var target:GameField;
    function Man(stage:Stage, t:GameField){
        target = t;
        stage.addEventListener( "keyDown", onKeyDown );
    }
    public function onKeyDown(e:KeyboardEvent):void{
        switch(e.keyCode){
            case 90:
                target.movingBlock.rotate(true);
                break;
            case 88:
                target.movingBlock.rotate(false);
                break;
            case 38:
                while( !target.movingBlock.move(0,1) ){}
                break;
            case 37:
                target.movingBlock.move(-1,0);
                break;   
            case 39:
                target.movingBlock.move(1,0);
                break;         
            case 40:
                target.movingBlock.move(0,1);
                break;
        }
    }
}

class CPU {
}

class Netmap extends BitmapData{
    function Netmap(){
        super( 3,3,false,0x666666 );
        setPixel(0,0,0x444444);
        setPixel(1,1,0x444444);
        setPixel(2,2,0x444444);
    }
}
